//! @file usb_descriptors.c,v
//!
//! 쌠 (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief USBҰ
//!
//! ̧ق͋Lqq\ʂĉpʂɎʂUSBҰ܂݂܂B
//!
//! @version 1.5 at90usb128-demo-touchscreen-1_0_0 $Id: usb_descriptors.c,v 1.5 2006/03/17 13:08:18 rletendu Exp $
//!
//! @todo
//! @bug

//_____ ݸٰ _______________________________________________________________

#include "config.h"
#include "conf_usb.h"

#include "usb_drv.h"
#include "usb_descriptors.h"
#include "usb_standard_request.h"
#include "usb_specific_request.h"

//_____ ϸ ___________________________________________________________________

//_____ ` __________________________________________________________________

// usb_user_device_descriptor
code S_usb_device_descriptor usb_dev_desc =
{
	sizeof(usb_dev_desc),
	DEVICE_DESCRIPTOR,
	Usb_write_word_enum_struc(USB_SPECIFICATION),
	DEVICE_CLASS,
	DEVICE_SUB_CLASS,
	DEVICE_PROTOCOL,
	EP_CONTROL_LENGTH,
	Usb_write_word_enum_struc(VENDOR_ID),
	Usb_write_word_enum_struc(PRODUCT_ID),
	Usb_write_word_enum_struc(RELEASE_NUMBER),
	MAN_INDEX,
	PROD_INDEX,
	SN_INDEX,
	NB_CONFIGURATION
};

// usb_user_configuration_descriptor FS
code S_usb_user_configuration_descriptor usb_conf_desc =
{
	{
		sizeof(S_usb_configuration_descriptor),
		CONFIGURATION_DESCRIPTOR,
		Usb_write_word_enum_struc(sizeof(S_usb_configuration_descriptor)\
								 +sizeof(S_usb_interface_descriptor)    \
								 +sizeof(S_usb_hid_descriptor)          \
								 +sizeof(S_usb_endpoint_descriptor)     \
		),
		NB_INTERFACE,
		CONF_NB,
		CONF_INDEX,
		CONF_ATTRIBUTES,
		MAX_POWER
	},
	{
		sizeof(S_usb_interface_descriptor),
		INTERFACE_DESCRIPTOR,
		INTERFACE_NB_TOUCHSCREEN,
		ALTERNATE_TOUCHSCREEN,
		NB_ENDPOINT_TOUCHSCREEN,
		INTERFACE_CLASS_TOUCHSCREEN,
		INTERFACE_SUB_CLASS_TOUCHSCREEN,
		INTERFACE_PROTOCOL_TOUCHSCREEN,
		INTERFACE_INDEX_TOUCHSCREEN
	},
	{
		sizeof(S_usb_hid_descriptor),
		HID_DESCRIPTOR,
		HID_BDC,
		HID_COUNTRY_CODE,
		HID_CLASS_DESC_NB,
		HID_DESCRIPTOR_TYPE,
		Usb_write_word_enum_struc(sizeof(S_usb_hid_report_descriptor_touchscreen))
	},
	{
		sizeof(S_usb_endpoint_descriptor),
		ENDPOINT_DESCRIPTOR,
		ENDPOINT_NB_1,
		EP_ATTRIBUTES_1,
		Usb_write_word_enum_struc(EP_SIZE_1),
		EP_INTERVAL_1
	}
};

// usb_user_manufacturer_string_descriptor
code S_usb_manufacturer_string_descriptor usb_user_manufacturer_string_descriptor =
{
	sizeof(usb_user_manufacturer_string_descriptor),
	STRING_DESCRIPTOR,
	USB_MANUFACTURER_NAME
};

// usb_user_product_string_descriptor
code S_usb_product_string_descriptor usb_user_product_string_descriptor =
{
	sizeof(usb_user_product_string_descriptor),
	STRING_DESCRIPTOR,
	USB_PRODUCT_NAME
};

// usb_user_serial_number
code S_usb_serial_number usb_user_serial_number =
{
	sizeof(usb_user_serial_number),
	STRING_DESCRIPTOR,
	USB_SERIAL_NUMBER
};

// usb_user_language_id
code S_usb_language_id usb_user_language_id =
{
	sizeof(usb_user_language_id),
	STRING_DESCRIPTOR,
	Usb_write_word_enum_struc(LANGUAGE_ID)
};

code S_usb_hid_report_descriptor_touchscreen usb_hid_report_descriptor_touchscreen =
{
	0x05, 0x01,			// USAGE_PAGE (W޽į)
	0x09, 0x02,			// USAGE (ڐG)
	0xA1, 0x01,			// COLLECTION (p)
	0x09, 0x01,			//   USAGE (߲)
	0xA1, 0x00,			//   COLLECTION ()
	0x05, 0x09,			//     USAGE_PAGE (t)
	0x19, 0x01,			//     USAGE_MINIMUM (t1)
	0x29, 0x03,			//     USAGE_MAXIMUM (t3)
	0x15, 0x00,			//     LOGICAL_MINIMUM (0)
	0x25, 0x01,			//     LOGICAL_MAXIMUM (1)
	0x75, 0x01,			//     REPORT_SIZE (1)
	0x95, 0x03,			//     REPORT_COUNT (3)
	0x81, 0x02,			//     INPUT (ް,ϐ,)
	0x75, 0x05,			//     REPORT_SIZE (5)
	0x95, 0x01,			//     REPORT_COUNT (1)
	0x81, 0x01,			//     INPUT (萔,z,)
	0x05, 0x01,			//     USAGE_PAGE (W޽į)
	0x09, 0x30,			//     USAGE (X)
	0x09, 0x31,			//     USAGE (Y)
	0x16, 0x01, 0xFC,	//     LOGICAL_MINIMUM (-1023)
	0x26, 0xFF, 0x03,	//     LOGICAL_MAXIMUM (1023)
	0x75, 0x0B,			//     REPORT_SIZE (11)
	0x95, 0x02,			//     REPORT_COUNT (2)
	0x81, 0x02,			//     INPUT (ް,ϐ,)
	0x75, 0x02,			//     REPORT_SIZE (2)
	0x95, 0x01,			//     REPORT_COUNT (1)
	0x81, 0x01,			//     INPUT (萔,z,)
	0xC0,				//     END_COLLECTION
	0xC0				// END_COLLECTION
};
