//! @file usb_drv.h,v
//!
//! 쌠 (c) 2006 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txţقǂ݂B
//!
//! @brief ̧قUSBײޒ`܂݂܂B
//!
//! @version 1.24 at90usb128-demo-touchscreen-1_0_0 $Id: usb_drv.h,v 1.24 2006/03/06 10:35:45 rletendu Exp $
//!
//! @todo
//! @bug

#ifndef _USB_DRV_H_
#define _USB_DRV_H_

//_____ ݸٰ _______________________________________________________________

typedef enum endpoint_parameter{ep_num, ep_type, ep_direction, ep_size, ep_bank, nyet_status} t_endpoint_parameter;

//! @defgroup USB_low_level_drivers USBײޕ
//! USBײޕ
//! @{

//_____ ϸ ___________________________________________________________________

#define MAX_EP_NB			7

#define EP_CONTROL			0
#define EP_1				1
#define EP_2				2
#define EP_3				3
#define EP_4				4
#define EP_5				5
#define EP_6				6
#define EP_7				7

#define PIPE_CONTROL		0
#define PIPE_0				0
#define PIPE_1				1
#define PIPE_2				2
#define PIPE_3				3
#define PIPE_4				4
#define PIPE_5				5
#define PIPE_6				6
#define PIPE_7				7

// USB߲
#define MSK_EP_DIR			0x7F
#define MSK_UADD			0x7F
#define MSK_EPTYPE			0xC0
#define MSK_EPSIZE			0x70
#define MSK_EPBK			0x0C
#define MSK_DTSEQ			0x0C
#define MSK_NBUSYBK			0x03
#define MSK_CURRBK			0x03
#define MSK_DAT				0xFF	// UEDATX
#define MSK_BYCTH			0x07	// UEBCHX
#define MSK_BYCTL			0xFF	// UEBCLX
#define MSK_EPINT			0x7F	// UEINT
#define MSK_HADDR			0xFF	// UHADDR

// USB߲
#define MSK_PNUM			0x07	// UPNUM
#define MSK_PRST			0x7F	// UPRST
#define MSK_PTYPE			0xC0	// UPCFG0X
#define MSK_PTOKEN			0x30
#define MSK_PEPNUM			0x0F
#define MSK_PSIZE			0x70	// UPCFG1X
#define MSK_PBK				0x0C

#define MSK_NBUSYBK			0x03

#define MSK_ERROR			0x1F

#define MSK_PTYPE			0xC0	// UPCFG0X
#define MSK_PTOKEN			0x30
#define MSK_TOKEN_SETUP		0x30
#define MSK_TOKEN_IN		0x10
#define MSK_TOKEN_OUT		0x20
#define MSK_PEPNUM			0x0F

#define MSK_PSIZE			0x70	// UPCFG1X
#define MSK_PBK				0x0C

// ߲Č`ԐݒpҰ
// ̒`ʹ߲Ă̋ƌ`ԐݒɎgplłB
#define TYPE_CONTROL		0
#define TYPE_ISOCHRONOUS	1
#define TYPE_BULK			2
#define TYPE_INTERRUPT		3
 //typedef enum ep_type {TYPE_CONTROL, TYPE_BULK, TYPE_ISOCHRONOUS, TYPE_INTERRUPT} e_ep_type;

#define DIRECTION_OUT		0
#define DIRECTION_IN		1
 //typedef enum ep_dir {DIRECTION_OUT, DIRECTION_IN} e_ep_dir;

#define SIZE_8				0
#define SIZE_16				1
#define SIZE_32				2
#define SIZE_64				3
#define SIZE_128			4
#define SIZE_256			5
#define SIZE_512			6
#define SIZE_1024			7
 //typedef enum ep_size {SIZE_8,   SIZE_16,  SIZE_32,  SIZE_64,
 //						 SIZE_128, SIZE_256, SIZE_512, SIZE_1024} e_ep_size;

#define ONE_BANK			0
#define TWO_BANKS			1
 //typedef enum ep_bank {ONE_BANK, TWO_BANKS} e_ep_bank;

#define NYET_ENABLED		0
#define NYET_DISABLED		1
 //typedef enum ep_nyet {NYET_DISABLED, NYET_ENABLED} e_ep_nyet;

#define TOKEN_SETUP			0
#define TOKEN_IN			1
#define TOKEN_OUT			2

//! @defgroup Endpoints_configuration ߲ėp`Ԑݒϸ
//! ߲߂ƴ߲Ă̌`ԐݒɎgpWϸۂ̈ꗗ
//! @{
#define Usb_build_ep_config0(type, dir, nyet)	((type<<6) | (nyet<<1) | (dir))
#define Usb_build_ep_config1(size, bank     )	((size<<4) | (bank<<2)        )
#define usb_configure_endpoint(num, type, dir, size, bank, nyet)\
							  ( Usb_select_endpoint(num),\
								usb_config_ep(Usb_build_ep_config0(type, dir, nyet),\
								Usb_build_ep_config1(size, bank)    ))

#define Host_build_pipe_config0(type, token, ep_num)	((type<<6) | (token<<4) | (ep_num))
#define Host_build_pipe_config1(size, bank     )	((size<<4) | (bank<<2)        )
#define host_configure_pipe(num, type, token,ep_num, size, bank, freq)\
						   ( Host_select_pipe(num),\
							 Host_set_interrupt_frequency(freq),\
							 host_config_pipe(Host_build_pipe_config0(type, token, ep_num),\
							 Host_build_pipe_config1(size, bank)    ))
//! @}

//! @defgroup USB_regulator USB߯ޒײ
//! USB߯ޒON/OFF؂ւ
//! @{
#define Usb_enable_regulator()				(UHWCON |= (1<<UVREGE))						//!< USB߯ޒ틖
#define Usb_disable_regulator()				(UHWCON &= ~(1<<UVREGE))					//!< USB߯ޒ֎~
#define Is_usb_regulator_enabled()			((UHWCON &  (1<<UVREGE))  ? TRUE : FALSE)	//!< 틖ޯČ
//! @}

//! @defgroup gen_usb USBʊǗײ
//! ϸۂUSBǗ܂B
//! @{
#define Usb_enable_uid_pin()				(UHWCON |=  (1<<UIDE))							//!< OUID݋
#define Usb_disable_uid_pin()				(UHWCON &= ~(1<<UIDE))							//!< OUID݋֎~
#define Usb_force_device_mode()				(Usb_disable_uid_pin(), UHWCON |=  (1<<UIMOD))	//!< OUDI݋֎~Au`ԋ
#define Usb_force_host_mode()				(Usb_disable_uid_pin(), UHWCON &= ~(1<<UIMOD))	//!< OUID݋֎~Aνē`ԋ
#define Usb_enable_uvcon_pin()				(UHWCON |=  (1<<UVCONE))						//!< OUVCON݋
#define Usb_disable_uvcon_pin()				(UHWCON &= ~(1<<UVCONE))						//!< OUVCON݋֎~
#define Usb_full_speed_mode()				(UHWCON |=  (1<<UDSS))							//!< S(Full-speed)u`Ԏgp(蓮`)
#define Usb_low_speed_mode()				(UHWCON &= ~(1<<UDSS))							//!< u`ԂɂĒᑬ(Low-speed)`ԋ

#define Usb_enable()						(USBCON |=  ((1<<USBE) | (1<<OTGPADE)))			//!< USB̪VBUS߯ނ̗
#define Usb_disable()						(USBCON &= ~((1<<USBE) | (1<<OTGPADE)))			//! USB̪VBUS߯ނ̗֎~
#define Is_usb_enabled()					((USBCON &   (1<<USBE)) ? TRUE : FALSE)

#define Usb_enable_vbus_pad()				(USBCON |=  (1<<OTGPADE))						//!< VBUS߯ދ
#define Usb_disable_vbus_pad()				(USBCON &= ~(1<<OTGPADE))						//!< VBUS߯ދ֎~

#define Usb_select_device()					(USBCON  &= ~(1<<HOST))
#define Usb_select_host()					(USBCON  |=  (1<<HOST))
#define Is_usb_host_enabled()				((USBCON  &  (1<<HOST)) ? TRUE : FALSE)

#define Usb_freeze_clock()					(USBCON  |=  (1<<FRZCLK))						//!< ̪œUSBۯ~(̪ ڼ޽)
#define Usb_unfreeze_clock()				(USBCON  &= ~(1<<FRZCLK))
#define Is_usb_clock_freezed()				((USBCON  &  (1<<FRZCLK)) ? TRUE : FALSE)

#define Usb_enable_id_interrupt()			(USBCON  |=  (1<<IDTE))
#define Usb_disable_id_interrupt()			(USBCON  &= ~(1<<IDTE))
#define Is_usb_id_interrupt_enabled()		((USBCON &   (1<<IDTE)) ? TRUE : FALSE)
#define Is_usb_id_device()					((USBSTA &   (1<<ID)) ? TRUE : FALSE)
#define Usb_ack_id_transition()				(USBINT  = ~(1<<IDTI))
#define Is_usb_id_transition()				((USBINT &  (1<<IDTI)) ? TRUE : FALSE)

#define Usb_enable_vbus_interrupt()			(USBCON  |=  (1<<VBUSTE))
#define Usb_disable_vbus_interrupt()		(USBCON  &= ~(1<<VBUSTE))
#define Is_usb_vbus_interrupt_enabled()		((USBCON &   (1<<VBUSTE)) ? TRUE : FALSE)
#define Is_usb_vbus_high()					((USBSTA &   (1<<VBUS)) ? TRUE : FALSE)
#define Is_usb_vbus_low()					((USBSTA &   (1<<VBUS)) ? FALSE : TRUE)
#define Usb_ack_vbus_transition()			(USBINT  = ~(1<<VBUSTI))
#define Is_usb_vbus_transition()			((USBINT &  (1<<VBUSTI)) ? TRUE : FALSE)

#define Usb_get_general_interrupt()			(USBINT &  (USBCON & MSK_IDTE_VBUSTE))			//!< USBSʊ荞(ꂽ荞)ԂB
#define Usb_ack_all_general_interrupt()		(USBINT = ~(USBCON & MSK_IDTE_VBUSTE))			//!< Sʊ荞(ꂽ荞)
#define Usb_ack_cache_id_transition(x)		((x)  &= ~(1<<IDTI))
#define Usb_ack_cache_vbus_transition(x)	((x)  &= ~(1<<VBUSTI))
#define Is_usb_cache_id_transition(x)		(((x) &   (1<<IDTI))  )
#define Is_usb_cache_vbus_transition(x)		(((x) &   (1<<VBUSTI)))

#define Usb_get_otg_interrupt()				(OTGINT &  OTGIEN)								//!< USB߯ފ荞(ꂽ荞)ԂB
#define Usb_ack_all_otg_interrupt()			(OTGINT = ~OTGIEN)								//! USB߯ފ荞(ꂽ荞)
#define Is_otg_cache_bconnection_error(x)	(((x) &   MSK_BCERRI))
#define Usb_ack_cache_bconnection_error(x)	((x)  &= ~MSK_BCERRI)

#define Usb_enter_dpram_mode()				(UDPADDH = (1<<DPACC))
#define Usb_exit_dpram_mode()				(UDPADDH = (U8)~(1<<DPACC))
#define Usb_set_dpram_address(addr)			(UDPADDH = (1<<DPACC) + ((Uint16)addr >> 8), UDPADDL = (Uchar)addr)
#define Usb_write_dpram_byte(val)			(UEDATX=val)
#define Usb_read_dpram_byte()				(UEDATX)

#define Usb_enable_vbus()					(OTGCON  |= (1<<VBUSREQ))						//!< VBUSpv
#define Usb_disable_vbus()					(OTGCON  |= (1<<VBUSRQC))						//!< VBUSspv
#define Usb_enable_manual_vbus()			(PORTE|=0x80,DDRE|=0x80,Usb_disable_uvcon_pin())	//!< USB̪UVCONMȂł̎蓮VBUSv

#define Usb_device_initiate_hnp()			(OTGCON  |=  (1<<HNPREQ))						//!< νĒK(HNP)
#define Usb_host_accept_hnp()				(OTGCON  |=  (1<<HNPREQ))						//!< νĒK󂯓
#define Usb_host_reject_hnp()				(OTGCON  &= ~(1<<HNPREQ))						//!< νĒK񋑔
#define Usb_device_initiate_srp()			(OTGCON  |=  (1<<SRPREQ))						//!< ԗvK(SRP)
#define Usb_select_vbus_srp_method()		(OTGCON  |=  (1<<SRPSEL))						//!< SRP̕@ƂVBUSI
#define Usb_select_data_srp_method()		(OTGCON  &= ~(1<<SRPSEL))						//!< SRP̕@ƂްI
#define Usb_enable_vbus_hw_control()		(OTGCON  &= ~(1<<VBUSHWC))						//!< VBUSłʰ޳䋖
#define Usb_disable_vbus_hw_control()		(OTGCON  |=  (1<<VBUSHWC))						//!< VBUSłʰ޳֎~
#define Is_usb_vbus_enabled()				((OTGCON &   (1<<VBUSREQ)) ? TRUE : FALSE)		//!< VBUSvĂ邩𒲍
#define Is_usb_hnp()						((OTGCON &   (1<<HNPREQ))  ? TRUE : FALSE)		//!< HNP
#define Is_usb_device_srp()					((OTGCON &   (1<<SRPREQ))  ? TRUE : FALSE)		//!< uSRP

#define Usb_enable_suspend_time_out_interrupt()		(OTGIEN  |=  (1<<STOE))					//!< x~Ԓߊ荞݋
#define Usb_disable_suspend_time_out_interrupt()	(OTGIEN  &= ~(1<<STOE))					//!< x~Ԓߊ荞݋֎~
#define Is_suspend_time_out_interrupt_enabled()		((OTGIEN &   (1<<STOE)) ? TRUE : FALSE)
#define Usb_ack_suspend_time_out_interrupt()		(OTGINT  &= ~(1<<STOI))					//!< x~Ԓߊ荞݉
#define Is_usb_suspend_time_out_interrupt()			((OTGINT &   (1<<STOI)) ? TRUE : FALSE)	//!< x~Ԓߔ

#define Usb_enable_hnp_error_interrupt()			(OTGIEN  |=  (1<<HNPERRE))				//!< HNPُ튄荞݋
#define Usb_disable_hnp_error_interrupt()			(OTGIEN  &= ~(1<<HNPERRE))				//!< HNPُ튄荞݋֎~
#define Is_hnp_error_interrupt_enabled()			((OTGIEN &   (1<<HNPERRE)) ? TRUE : FALSE)
#define Usb_ack_hnp_error_interrupt()				(OTGINT  &= ~(1<<HNPERRI))				//!< HNPُ튄荞݉
#define Is_usb_hnp_error_interrupt()				((OTGINT &   (1<<HNPERRI)) ? TRUE : FALSE)	//!< HNPُ픭

#define Usb_enable_role_exchange_interrupt()		(OTGIEN  |=  (1<<ROLEEXE))				//!< ϊ荞݋
#define Usb_disable_role_exchange_interrupt()		(OTGIEN  &= ~(1<<ROLEEXE))				//!< ύX荞݋֎~
#define Is_role_exchange_interrupt_enabled()		((OTGIEN &   (1<<ROLEEXE)) ? TRUE : FALSE)
#define Usb_ack_role_exchange_interrupt()			(OTGINT  &= ~(1<<ROLEEXI))				//!< ϊ荞݉
#define Is_usb_role_exchange_interrupt()			((OTGINT &   (1<<ROLEEXI)) ? TRUE : FALSE)	//!< ϊ

#define Usb_enable_bconnection_error_interrupt()	(OTGIEN  |=  (1<<BCERRE))				//!< Buڑُ튄荞݋
#define Usb_disable_bconnection_error_interrupt()	(OTGIEN  &= ~(1<<BCERRE))				//!< Buڑُ튄荞݋֎~
#define Is_bconnection_error_interrupt_enabled()	((OTGIEN &   (1<<BCERRE)) ? TRUE : FALSE)
#define Usb_ack_bconnection_error_interrupt()		(OTGINT  &= ~(1<<BCERRI))				//!< Buڑُ튄荞݉
#define Is_usb_bconnection_error_interrupt()		((OTGINT &   (1<<BCERRI)) ? TRUE : FALSE)	//!< Buڑُ픭

#define Usb_enable_vbus_error_interrupt()			(OTGIEN  |=  (1<<VBERRE))				//!< VBUSُ튄荞݋
#define Usb_disable_vbus_error_interrupt()			(OTGIEN  &= ~(1<<VBERRE))				//!< VBUSُ튄荞݋֎~
#define Is_vbus_error_interrupt_enabled()			((OTGIEN &   (1<<VBERRE)) ? TRUE : FALSE)
#define Usb_ack_vbus_error_interrupt()				(OTGINT  &= ~(1<<VBERRI))				//!< VBUSُ튄荞݉
#define Is_usb_vbus_error_interrupt()				((OTGINT &   (1<<VBERRI)) ? TRUE : FALSE)	//!< VBUSُ픭

#define Usb_enable_srp_interrupt()					(OTGIEN  |=  (1<<SRPE))					//!< SRP荞݋
#define Usb_disable_srp_interrupt()					(OTGIEN  &= ~(1<<SRPE))					//!< SRP荞݋֎~
#define Is_srp_interrupt_enabled()					((OTGIEN &   (1<<SRPE)) ? TRUE : FALSE)
#define Usb_ack_srp_interrupt()						(OTGINT  &= ~(1<<SRPI))					//!< SRP荞݉
#define Is_usb_srp_interrupt()						((OTGINT &   (1<<SRPI)) ? TRUE : FALSE)	//!< SRP
//! @}

//! @defgroup USB_device_driver USBuײ
//! ϸۂUSBuǗ܂B
//! @{
#define Usb_initiate_remote_wake_up()				(UDCON   |=  (1<<RMWKUP))				//!< uN
#define Usb_detach()								(UDCON   |=  (1<<DETACH))				//!< USB޽̕
#define Usb_attach()								(UDCON   &= ~(1<<DETACH))				//!< USB޽ւ̕t(ڑ)
#define Is_usb_pending_remote_wake_up()				((UDCON & (1<<RMWKUP)) ? TRUE : FALSE)	//!< uNĂ邩
#define Is_usb_detached()							((UDCON & (1<<DETACH)) ? TRUE : FALSE)	//!< uĂ邩

#define Usb_get_device_interrupt()					(UDINT &  (1<<UDIEN))					//!< USBu荞(ꊄ荞)ԂB
#define Usb_ack_all_device_interrupt()				(UDINT = ~(1<<UDIEN))					//!< USBu荞(ꊄ荞)

#define Usb_enable_remote_wake_up_interrupt()		(UDIEN  |=  (1<<UPRSME))				//!< uN荞݋
#define Usb_disable_remote_wake_up_interrupt()		(UDIEN  &= ~(1<<UPRSME))				//!< uN荞݋֎~
#define Is_remote_wake_up_interrupt_enabled()		((UDIEN &   (1<<UPRSME)) ? TRUE : FALSE)
#define Usb_ack_remote_wake_up_start()				(UDINT  =  ~(1<<UPRSMI))				//!< uN
#define Is_usb_remote_wake_up_start()				((UDINT &   (1<<UPRSMI)) ? TRUE : FALSE)	//!< uNĂ邩

#define Usb_enable_resume_interrupt()				(UDIEN |=  (1<<EORSME))					//!< ĊJ荞݋
#define Usb_disable_resume_interrupt()				(UDIEN &= ~(1<<EORSME))					//!< ĊJ荞݋֎~
#define Is_resume_interrupt_enabled()				((UDIEN &  (1<<EORSME)) ? TRUE : FALSE)
#define Usb_ack_resume()							(UDINT  = ~(1<<EORSMI))					//!< ĊJ
#define Is_usb_resume()								((UDINT &  (1<<EORSMI)) ? TRUE : FALSE)	//!< ĊJ

#define Usb_enable_wake_up_interrupt()				(UDIEN |=  (1<<WAKEUPE))				//!< N荞݋
#define Usb_disable_wake_up_interrupt()				(UDIEN &= ~(1<<WAKEUPE))				//!< N荞݋֎~
#define Is_swake_up_interrupt_enabled()				((UDIEN &  (1<<WAKEUPE)) ? TRUE : FALSE)
#define Usb_ack_wake_up()							(UDINT  = ~(1<<WAKEUPI))				//!< N
#define Is_usb_wake_up()							((UDINT &  (1<<WAKEUPI)) ? TRUE : FALSE)	//!< N

#define Usb_enable_reset_interrupt()				(UDIEN |=  (1<<EORSTE))					//!< USBؾĊ荞݋
#define Usb_disable_reset_interrupt()				(UDIEN &= ~(1<<EORSTE))					//!< USBؾĊ荞݋֎~
#define Is_reset_interrupt_enabled()				((UDIEN &  (1<<EORSTE)) ? TRUE : FALSE)
#define Usb_ack_reset()								(UDINT  = ~(1<<EORSTI))					//!< USBؾĉ
#define Is_usb_reset()								((UDINT &  (1<<EORSTI)) ? TRUE : FALSE)	//!< USBؾĔ

#define Usb_enable_sof_interrupt()					(UDIEN |=  (1<<SOFE))					//!< ڰъJn荞݋
#define Usb_disable_sof_interrupt()					(UDIEN &= ~(1<<SOFE))					//!< ڰъJn荞݋֎~
#define Is_sof_interrupt_enabled()					((UDIEN &  (1<<SOFE)) ? TRUE : FALSE)
#define Usb_ack_sof()								(UDINT  = ~(1<<SOFI))					//!< ڰъJn
#define Is_usb_sof()								((UDINT &  (1<<SOFI)) ? TRUE : FALSE)	//!< ڰъJn

#define Usb_enable_suspend_interrupt()				(UDIEN |=  (1<<SUSPE))					//!< x~Ԋ荞݋
#define Usb_disable_suspend_interrupt()				(UDIEN &= ~(1<<SUSPE))					//!< x~Ԋ荞݋֎~
#define Is_suspend_interrupt_enabled()				((UDIEN &  (1<<SUSPE)) ? TRUE : FALSE)
#define Usb_ack_suspend()							(UDINT  = ~(1<<SUSPI))					//!< x~
#define Is_usb_suspend()							((UDINT &  (1<<SUSPI)) ? TRUE : FALSE)	//!< x~Ԍo

#define Usb_enable_address()						(UDADDR |=  (1<<ADDEN))					//!< USBuڽ
#define Usb_disable_address()						(UDADDR &= ~(1<<ADDEN))					//!< USBuڽ֎~
#define Usb_configure_address(addr)					(UDADDR  =  (UDADDR & (1<<ADDEN)) | ((U8)addr & MSK_UADD))	//!< USBuڽݒ

#define Usb_frame_number()							((U16)((((U16)UDFNUMH) << 8) | ((U16)UDFNUML)))	//!< ŌڰєԍԂB
#define Is_usb_frame_number_crc_error()				((UDMFN & (1<<FNCERR)) ? TRUE : FALSE)	//!< ڰєԍCRCُ픭
//! @}

//! @defgroup usb_gen_ep USB߲ ײ
//! ϸۂʹ߲Ă̈ʓIȋ@\Ǘ܂B
//! @{
#define Usb_select_endpoint(ep)						(UENUM = (U8)ep )						//!< CPUƲ̪߲ĔԍI

#define Usb_reset_endpoint(ep)						(UERST = 1 << (U8)ep, UERST = 0)		//!< I߲Ăؾ

#define Usb_enable_endpoint()						(UECONX  |=  (1<<EPEN))					//!< ̴݂߲Ă
#define Usb_enable_stall_handshake()				(UECONX  |=  (1<<STALLRQ))				//!< ̒Pʓ]ɑ΂STALL޼
#define Usb_reset_data_toggle()						(UECONX  |=  (1<<RSTDT))				//!< ްݐ؂ւ菇ؾ
#define Usb_disable_endpoint()						(UECONX  &= ~(1<<EPEN))					//!< ̴݂߲Ă֎~
#define Usb_disable_stall_handshake()				(UECONX  |=  (1<<STALLRQC))				//!< STALL޼֎~
#define Usb_select_epnum_for_cpu()					(UECONX  &= ~(1<<EPNUMS))				//!< CPUŲ̪߲ĂI
#define Is_usb_endpoint_enabled()					((UECONX & (1<<EPEN))    ? TRUE : FALSE)	//!< ̴݂߲Ă
#define Is_usb_endpoint_stall_requested()			((UECONX & (1<<STALLRQ)) ? TRUE : FALSE)	//!< STALL޼vĂ邩

#define Usb_configure_endpoint_type(type)			(UECFG0X = (UECFG0X & ~(MSK_EPTYPE)) | ((U8)type << 6))	//!< ̴݂߲Ă`Ԑݒ
#define Usb_configure_endpoint_direction(dir)		(UECFG0X = (UECFG0X & ~(1<<EPDIR)) | ((U8)dir))			//!< ̴݂߲ĕ`Ԑݒ

#define Usb_configure_endpoint_size(size)			(UECFG1X = (UECFG1X & ~MSK_EPSIZE) | ((U8)size << 4))		//!< ̴݂߲ėeʂ`Ԑݒ
#define Usb_configure_endpoint_bank(bank)			(UECFG1X = (UECFG1X & ~MSK_EPBK)   | ((U8)bank << 2))		//!< ̴݂߲Ăݸ`Ԑݒ
#define Usb_allocate_memory()						(UECFG1X |=  (1<<ALLOC))				//!< DPRAMŌ݂̌`Ԑݒ蓖
#define Usb_unallocate_memory()						(UECFG1X &= ~(1<<ALLOC))				//!< DPRAMŌ݂̌`Ԑݒ蓖ĉ

#define Usb_ack_overflow_interrupt()				(UESTA0X &= ~(1<<OVERFI))				//!< ߲Ĉꊄ荞݉
#define Usb_ack_underflow_interrupt()				(UESTA0X &= ~(1<<UNDERFI))				//!< ߲ ؘRꉞ
#define Usb_ack_zlp()								(UESTA0X &= ~(1<<ZLPSEEN))				//!< 0߹ĎM
#define Usb_data_toggle()							((UESTA0X&MSK_DTSEQ) >> 2)				//!< ްݐ؂ւlԂB
#define Usb_nb_busy_bank()							(UESTA0X &  MSK_NBUSYBK)				//!< ZݸԍԂB
#define Is_usb_one_bank_busy()						((UESTA0X & MSK_NBUSYBK) == 0 ? FALSE : TRUE)	//!< Œ1ݸZ
#define Is_endpoint_configured()					((UESTA0X & (1<<CFGOK))   ? TRUE : FALSE)		//!< ̴݂߲Ă`Ԑݒ肳Ă邩
#define Is_usb_overflow()							((UESTA0X & (1<<OVERFI))  ? TRUE : FALSE)		//!< ꔭ
#define Is_usb_underflow()							((UESTA0X & (1<<UNDERFI)) ? TRUE : FALSE)		//!< Rꔭ
#define Is_usb_zlp()								((UESTA0X & (1<<ZLPSEEN)) ? TRUE : FALSE)		//!< 0߹Čo

#define Usb_control_direction()						((UESTA1X & (1<<CTRLDIR)) >> 2)			//!< ԂB
#define Usb_current_bank()							( UESTA1X & MSK_CURRBK)					//!< ݂ݸԍԂB

#define Usb_ack_fifocon()							(UEINTX &= ~(1<<FIFOCON))				//!< FIFOCONޯĉ(0)
#define Usb_ack_nak_in()							(UEINTX &= ~(1<<NAKINI))				//!< NAK INM
#define Usb_ack_nak_out()							(UEINTX &= ~(1<<NAKOUTI))				//!< NAK OUTM
#define Usb_ack_receive_setup()						(UEINTX &= ~(1<<RXSTPI))				//!< SETUPM
#define Usb_ack_receive_out()						(UEINTX &= ~(1<<RXOUTI), Usb_ack_fifocon())	//!< OUTM
#define Usb_ack_stalled()							(MSK_STALLEDI = 0)						//!< STALLo
#define Usb_ack_in_ready()							(UEINTX &= ~(1<<TXINI), Usb_ack_fifocon())	//!< IN
#define Usb_kill_last_in_bank()						(UENTTX |= (1<<RXOUTI))					//!< Ōݸ
#define Is_usb_read_enabled()						(UEINTX&(1<<RWAL))						//!< ߲ēǂݍ݉
#define Is_usb_write_enabled()						(UEINTX&(1<<RWAL))						//!< ߲ď݉
#define Is_usb_read_control_enabled()				(UEINTX&(1<<TXINI))						//!< ߲Ăœǂݍ݉
#define Is_usb_receive_setup()						(UEINTX&(1<<RXSTPI))					//!< SETUPM
#define Is_usb_receive_out()						(UEINTX&(1<<RXOUTI))					//!< OUTM
#define Is_usb_in_ready()							(UEINTX&(1<<TXINI))						//!< IN
#define Usb_send_in()								(UEINTX &= ~(1<<FIFOCON))				//!< INo
#define Usb_send_control_in()						(UEINTX &= ~(1<<TXINI))					//!< ߲ĂINo
#define Usb_free_out_bank()							(UEINTX &= ~(1<<FIFOCON))				//!< OUTݸJ
#define Usb_ack_control_out()						(UEINTX &= ~(1<<RXOUTI))				//!< ߲ĂOUT

#define Usb_enable_flow_error_interrupt()			(UEIENX |=  (1<<FLERRE))				//!< ُ튄荞݋
#define Usb_enable_nak_in_interrupt()				(UEIENX |=  (1<<NAKINE))				//!< NAK IN荞݋
#define Usb_enable_nak_out_interrupt()				(UEIENX |=  (1<<NAKOUTE))				//!< NAK OUT荞݋
#define Usb_enable_receive_setup_interrupt()		(UEIENX |=  (1<<RXSTPE))				//!< SETUPM荞݋
#define Usb_enable_receive_out_interrupt()			(UEIENX |=  (1<<RXOUTE))				//!< OUTM荞݋
#define Usb_enable_stalled_interrupt()				(UEIENX |=  (1<<STALLEDE))				//!< STALLo荞݋
#define Usb_enable_in_ready_interrupt()				(UEIENX |=  (1<<TXIN))					//!< IN荞݋
#define Usb_disable_flow_error_interrupt()			(UEIENX &= ~(1<<FLERRE))				//!< ُ튄荞݋֎~
#define Usb_disable_nak_in_interrupt()				(UEIENX &= ~(1<<NAKINE))				//!< NAK IN荞݋֎~
#define Usb_disable_nak_out_interrupt()				(UEIENX &= ~(1<<NAKOUTE))				//!< NAK OUT荞݋֎~
#define Usb_disable_receive_setup_interrupt()		(UEIENX &= ~(1<<RXSTPE))				//!< SETUPM荞݋֎~
#define Usb_disable_receive_out_interrupt()			(UEIENX &= ~(1<<RXOUTE))				//!< OUTM荞݋֎~
#define Usb_disable_stalled_interrupt()				(UEIENX &= ~(1<<STALLEDE))				//!< STALLo荞݋֎~
#define Usb_disable_in_ready_interrupt()			(UEIENX &= ~(1<<TXIN))					//!< IN荞݋֎~

#define Usb_read_byte()								(UEDATX)								//!< ̴݂߲Ăɑ΂FIFO޲ĂԂB
#define Usb_write_byte(byte)						(UEDATX = (U8)byte)						//!< ̴݂߲Ăɑ΂FIFȌ޲

#define Usb_byte_counter()							((((U16)UEBCHX) << 8) | (UEBCLX))		//!< ̴݂߲FIFO޲Đ(16ޯ)ԂB
#define Usb_byte_counter_8()						((U8)UEBCLX)							//!< ̴݂߲FIFO޲Đ(8ޯ)ԂB

#define Usb_interrupt_flags()						(UEINT != 0x00)							//!< Sʴ߲Ċ荞׸ތ
#define Is_usb_endpoint_event()						(Usb_interrupt_flags())					//!< Sʴ߲Ċ荞׸ތ

// xϸ
#define Usb_select_ep_for_cpu(ep)					(Usb_select_epnum_for_cpu(), Usb_select_endpoint(ep))

//! @}

//! @defgroup host_management USBνĐײ
//! ϸۂUSBνĐǗ܂B
//! @{
#define Host_allocate_memory()						(UPCFG1X |=  (1<<ALLOC))				//!< DPRAMŌ݂̌`Ԑݒ蓖
#define Host_unallocate_memory()					(UPCFG1X &= ~(1<<ALLOC))				//!< DPRAMŌ݂̌`Ԑݒ蓖ĉ

#define Host_enable()								(USBCON |= (1<<HOST))					//!< USBνċ@\
#define Host_enable_sof()							(UHCON |=  (1<<SOFEN))					//!< SOF
#define Host_disable_sof()							(UHCON &= ~(1<<SOFEN))					//!< SOF֎~
#define Host_send_reset()							(UHCON |= (1<<RESET))					//!< uUSBؾđo
#define Host_is_reset()								((UHCON & (1<<RESET)) ? TRUE : FALSE)	//!< USBؾĂ
#define Host_send_resume()							(UHCON |= (1<<RESUME))					//!< uUSBĊJo
#define Host_is_resume()							((UHCON & (1<<RESUME)) ? TRUE : FALSE)	//!< USBĊJ

#define Host_enable_sof_interrupt()					(UHIEN |=  (1<<HSOFE))					//!< ν ڰъJn荞݋
#define Host_disable_sof_interrupt()				(UHIEN &= ~(1<<HSOFE))					//!< ν ڰъJn荞݋֎~
#define Is_host_sof_interrupt_enabled()				((UHIEN &  (1<<HSOFE)) ? TRUE : FALSE)
#define Host_is_sof()								((UHINT &  (1<<HSOFI)) ? TRUE : FALSE)	//!< SOFo
#define Is_host_sof()								((UHINT &  (1<<HSOFI)) ? TRUE : FALSE)
#define Host_ack_sof()								(UHINT &= ~(1<<HSOFI))

#define Host_enable_hwup_interrupt()				(UHIEN |=  (1<<HWUPE))					//!< νċN荞݌o
#define Host_disable_hwup_interrupt()				(UHIEN &= ~(1<<HWUPE))					//!< νċN荞݌o֎~
#define Is_host_hwup_interrupt_enabled()			((UHIEN &  (1<<HWUPE)) ? TRUE : FALSE)
#define Host_is_hwup()								((UHINT &  (1<<HWUPI)) ? TRUE : FALSE)	//!< νċNo
#define Is_host_hwup()								((UHINT &  (1<<HWUPI)) ? TRUE : FALSE)	//!< νċNo
#define Host_ack_hwup()								(UHINT &= ~(1<<HWUPI))

#define Host_enable_down_stream_resume_interrupt()	(UHIEN |=  (1<<RSMEDE))					//!< νĉRSMo荞݌o
#define Host_disable_down_stream_resume_interrupt()	(UHIEN &= ~(1<<RSMEDE))					//!< νĉRSMo荞݌o֎~
#define Is_host_down_stream_resume_interrupt_enabled()	((UHIEN & (1<<RSMEDE)) ? TRUE : FALSE)
#define Is_host_down_stream_resume()				((UHINT &  (1<<RSMEDI)) ? TRUE : FALSE)	//!< νĉRSMo
#define Host_ack_down_stream_resume()				(UHINT &= ~(1<<RSMEDI))

#define Host_enable_remote_wakeup_interrupt()		(UHIEN |=  (1<<RXRSME))					//!< νĉuN荞݌o
#define Host_disable_remote_wakeup_interrupt()		(UHIEN &= ~(1<<RXRSME))					//!< νĉuN荞݌o֎~
#define Is_host_remote_wakeup_interrupt_enabled()	((UHIEN &  (1<<RXRSME)) ? TRUE : FALSE)
#define Host_is_remote_wakeup()						((UHINT &  (1<<RXRSMI)) ? TRUE : FALSE)	//!< νċNo
#define Is_host_remote_wakeup()						((UHINT &  (1<<RXRSMI)) ? TRUE : FALSE)	//!< νċNo
#define Host_ack_remote_wakeup()					(UHINT &= ~(1<<RXRSMI))

#define Host_enable_device_connection_interrupt()	(UHIEN |=  (1<<DCONNE))					//!< νđuڑ荞݋
#define Host_disable_device_connection_interrupt()	(UHIEN &= ~(1<<DCONNE))					//!< USBuڑ荞݋֎~
#define Is_host_device_connection_interrupt_enabled()	((UHIEN & (1<<DCONNE)) ? TRUE : FALSE)
#define Is_device_connection()						(UHINT &  (1<<DCONNI))					//!< USBuo
#define Host_ack_device_connection()				(UHINT = ~(1<<DCONNI))					//!< uڑ

#define Host_enable_device_disconnection_interrupt()	(UHIEN |=  (1<<DDISCE))				//!< νđuؒf荞݋
#define Host_disable_device_disconnection_interrupt()	(UHIEN &= ~(1<<DDISCE))				//!< USBuؒf荞݋֎~
#define Is_host_device_disconnection_interrupt_enabled()	((UHIEN & (1<<DDISCE)) ? TRUE : FALSE)
#define Is_device_disconnection()					(UHINT &  (1<<DDISCI) ? TRUE : FALSE)	//!< USBuO
#define Host_ack_device_disconnection()				(UHINT = ~(1<<DDISCI))					//!< uؒf

#define Host_enable_reset_interrupt()				(UHIEN |=  (1<<RSTE))					//!< νUSBؾĊ荞݋
#define Host_disable_reset_interrupt()				(UHIEN &= ~(1<<RSTE))					//!< νUSBؾĊ荞݋֎~
#define Is_host_reset_interrupt_enabled()			((UHIEN &  (1<<RSTE)) ? TRUE : FALSE)
#define Host_ack_reset()							(UHINT  = ~(1<<RSTI))					//!< νUSBؾđo
#define Is_host_reset()								Host_is_reset()							//!< USBؾđo

#define Host_vbus_request()							(OTGCON |= (1<<VBUSREQ))				//!< VBUS؂ւ
#define Host_clear_vbus_request()					(OTGCON |= (1<<VBUSRQC))				//!< VBUS OFF؂ւ
#define Host_configure_address(addr)				(UHADDR = addr & MSK_HADDR)				//!< uɎgpڽ`Ԑݒ
//! @}

//! @defgroup genral_pipe USB߲ ײ
//! ϸۂ߲߂̈ʓIȋ@\Ǘ܂B
//! @{
#define Host_select_pipe(p)							(UPNUM = (U8)p)							//!< CPU̪p߲߂I

#define Host_enable_pipe()							(UPCONX |=  (1<<PEN))					//!< ߲ߋ
#define Host_disable_pipe()							(UPCONX &= ~(1<<PEN))					//!< ߲ߋ֎~

#define Host_set_token_setup()						(UPCFG0X =  UPCFG0X & ~MSK_TOKEN_SETUP)	//!< SETUPw[ݒ
#define Host_set_token_in()							(UPCFG0X = (UPCFG0X & ~MSK_TOKEN_SETUP) | MSK_TOKEN_IN)		//!< INw[ݒ
#define Host_set_token_out()						(UPCFG0X = (UPCFG0X & ~MSK_TOKEN_SETUP) | MSK_TOKEN_OUT)	//!< OUTw[ݒ

#define Host_get_endpoint_number()					(UPCFG0X & (1<<MSK_PEPNUM))				//!< ݂߲߂ƘAg߲ĔԍԂB

#define Host_set_interrupt_frequency(frq)			(UPCFG2X = (U8)frq)						//!< 荞ݎgݒ

#define Is_pipe_configured()						(UPSTAX  & (1<<CFGOK))					//!< ݂߲߂`Ԑݒ肳Ă邩
#define Is_host_one_bank_busy()						((UPSTAX & (1<<MSK_NBUSYBK)) != 0)		//!< Œ1ݸZ
#define Host_number_of_busy_bank()					(UPSTAX &  (1<<MSK_NBUSYBK))			//!< ZݸԍԂB

#define Host_reset_pipe(p)							(UPRST = 1<<p , UPRST = 0)				//!< ߲ ؾ

#define Host_write_byte(dat)						(UPDATX = dat)							//!< ߲߂FIFO޲ď
#define Host_read_byte()							(UPDATX)								//!< ߲߂FIFO޲ēǂݍ

#define Host_freeze_pipe()							(UPCONX |=  (1<<PFREEZE))				//!< ߲ߓ
#define Host_unfreeze_pipe()						(UPCONX &= ~(1<<PFREEZE))				//!< ߲ߓ
#define Is_host_pipe_freeze()						(UPCONX &   (1<<PFREEZE))				//!< ݂߲߂

#define Host_reset_pipe_data_toggle()				(UPCONX |= (1<<RSTDT))					//!< ްݐ؂ւؾ

#define Is_host_setup_sent()						((UPINTX & (1<<TXSTPI)) ? TRUE : FALSE)	//!< SETUPo
#define Is_host_control_in_received()				((UPINTX & (1<<RXINI)) ? TRUE : FALSE)	//!< INM
#define Is_host_control_out_sent()					((UPINTX & (1<<TXOUTI)) ? TRUE : FALSE)	//!< OUTM
#define Is_host_stall()								((UPINTX & (1<<RXSTALLI)) ? TRUE : FALSE)	//!< STALLM
#define Is_host_pipe_error()						((UPINTX & (1<<PERRI)) ? TRUE : FALSE)	//!< ߲߂ňُ픭
#define Host_send_setup()							(UPINTX  &= ~(1<<FIFOCON))				//!< SETUPo
#define Host_send_control_in()						(UPINTX  &= ~(1<<FIFOCON))				//!< INo
#define Host_send_control_out()						(UPINTX  &= ~(1<<FIFOCON))				//!< OUTo
#define Host_ack_control_out()						(UPINTX  &= ~(1<<TXOUTI))				//!< OUT
#define Host_ack_control_in()						(UPINTX  &= ~(1<<RXINI))				//!< IN
#define Host_ack_setup()							(UPINTX  &= ~(1<<TXOUTI))				//!< SETUP
#define Host_ack_stall()							(UPINTX  &= ~(1<<RXSTALLI))				//!< STALLM

#define Host_send_out()								(UPINTX = 0x7B)							//!< OUTo
#define Is_host_out_sent()							((UPINTX & (1<<TXOUTI)) ? TRUE : FALSE)	//!< OUTo
#define Host_ack_out_sent()							(UPINTX = 0xFB)							//!< OUTo
#define Is_host_in_received()						((UPINTX & (1<<FIFOCON)) ? TRUE : FALSE)	//!< INM
#define Host_ack_in_received()						(UPINTX = 0x7E)							//!< INM

#define Is_host_read_enabled()						(UPINTX&(1<<RWAL))						//!< ߲ēǂݍ݉
#define Is_host_write_enabled()						(UPINTX&(1<<RWAL))						//!< ߲ď݉

#define Host_standard_in_mode()						(UPCONX &= ~(1<<INMODE))				//!< W`ԂINݒ
#define Host_continuous_in_mode()					(UPCONX |=  (1<<INMODE))				//!> p`ԂINݒ

#define Host_in_request_number(in_num)				(UPINRQX = (U8)in_num)					//!< OɎsINvݒ
#define Host_get_in_request_number()				(UPINRQX)								//!< cINvԂB

#define Host_data_length_U8()						(UPBCLX)								//!< ޲Đ(8ޯ)ԂB
#define Host_data_length_U16()						((((U16)UPBCHX)<<8) | UPBCLX)			//!< ޲Đ(16ޯ)ԂB
#define Host_byte_counter()							Host_data_length_U16()					//!< u݊p
#define Host_byte_counter_8()						Host_data_length_U8()					//!< u݊p

#define Host_get_pipe_length()						((U16)0x08 << ((UPCFG1X & MSK_PSIZE)>>4))	//!< ݂߲߂̑傫ԂB

#define Host_error_status()							(UPERRX & MSK_ERROR)					//!< ߲߂ňُ픭
#define Host_ack_all_errors()						(UPERRX = 0x00)							//!< S߲߈ُ퉞

#define Host_enable_transmit_interrupt()			(UPIENX |=  (1<<TXOUTE))				//!< ߲ߑMI荞݋
#define Host_disable_transmit_interrupt()			(UPIENX &= ~(1<<TXOUTE))				//!< ߲ߑMI荞݋֎~

#define Host_enable_receive_interrupt()				(UPIENX |=  (1<<RXINE))					//!< ߲ߎM荞݋
#define Host_disable_receive_interrupt()			(UPIENX &= ~(1<<RXINE))					//!< ߲ߎM荞݋֎~

#define Get_pipe_token(x)							((x & (0x80)) ? TOKEN_IN : TOKEN_OUT)

#define Host_set_device_supported()					(device_status |=  0x01)
#define Host_clear_device_supported()				(device_status &= ~0x01)
#define Is_host_device_supported()					(device_status &   0x01)

#define Host_set_device_ready()						(device_status |=  0x02)
#define Host_clear_device_ready()					(device_status &= ~0x02)
#define Is_host_device_ready()						(device_status &   0x02)

#define Host_set_configured()						(device_status |=  0x04)
#define Host_clear_configured()						(device_status &= ~0x04)
#define Is_host_configured()						(device_status &   0x04)

#define Host_clear_device_status()					(device_status =   0x00)
//! @}

//! wSWAP
//! ϸۂ͌U8܂B
//!
//! @param	x	(U16) 16ޯČ
//!
//! @return		(U16) ꂽ2޲Ă16ޯČx

#define wSWAP(x)        \
  (   (((x)>>8)&0x00FF) \
  |   (((x)<<8)&0xFF00) \
  )

//! Usb_write_word_enum_struc
//! ϸۂUSB񋓍\̓U16𖞂̂菕܂B
//! CPU\ɈˑāAϸۂق邩A܂͂܂B
//!
//! @param	x	(U16) ׂ16ޯČ
//!
//! @return		(U16) ꂽ16ޯČ
#if !defined(BIG_ENDIAN) && !defined(LITTLE_ENDIAN)
  #error YOU MUST Define the Endian Type of target: LITTLE_ENDIAN or BIG_ENDIAN
#endif
#ifdef LITTLE_ENDIAN
  #define Usb_write_word_enum_struc(x)	(x)
#else //BIG_ENDIAN
  #define Usb_write_word_enum_struc(x)	(wSWAP(x))
#endif

//! @}

//_____ 錾 __________________________________________________________________

U8		usb_config_ep					(U8, U8);
U8		usb_select_enpoint_interrupt	(void);
U16		usb_get_nb_byte_epw				(void);
U8		usb_send_packet					(U8, U8*, U8);
U8		usb_read_packet					(U8, U8*, U8);
void	usb_halt_endpoint				(U8);
void	usb_reset_endpoint				(U8);
U8		usb_init_device					(void);

U8		host_config_pipe				(U8, U8);
U8		host_determine_pipe_size		(U16);
void	host_disable_all_pipe			(void);

#endif // _USB_DRV_H_
